function dummy=ceclatextable(fnumbers,dim)
dummy = [];

nfun = length(fnumbers);
if dim <= 10
    table = zeros(3*7,nfun);
else
    table = zeros(4*7,nfun);
end
    

outfile = strcat(['errortable_f',num2str(fnumbers(1)),'-f',...
    num2str(fnumbers(end)),'_',num2str(dim),'D.tex']);
for i = 1:length(fnumbers)
    % file and directory names
    filename = strcat(['fvalues_f',num2str(fnumbers(i)),'_',num2str(dim),'D.dat']);
    dirname  = strcat(['fun',num2str(fnumbers(i))]);
    
    % change wdir 
    eval(['cd ',dirname]);
    
    % read data 
    fid = fopen(filename,'r');
    if (fid ==-1)
        disp(filename);
        warning('file not found!');                   
        table(1:7,i)   = NaN;
        table(8:14,i)  = NaN;
        table(15:21,i) = NaN;
        if dim > 10
            table(22:28,i) = NaN;
        end           
    else
        line1=fscanf(fid,'%f',8);
        line2=fscanf(fid,'%f',8);
        line3=fscanf(fid,'%f',8);
        if dim>10
            line4=fscanf(fid,'%f',8);   
        end
        fclose(fid); 
    
        table(1:7,i)   = line1(2:8);
        table(8:14,i)  = line2(2:8);
        table(15:21,i) = line3(2:8);
        if dim > 10
            table(22:28,i) = line4(2:8);
        end    
    end
    cd ../;
end

% open latex file
fid = fopen(outfile,'w');
fprintf(fid,'\\begin{table}\n');
fprintf(fid,'\\begin{center}\n');
fprintf(fid,'{\\scriptsize\n');
fprintf(fid,'\\caption{caption...}\n');
firstline = '\\begin{tabular}{|@{$\\,$}l@{$\\,$}|@{$\\,$}l@{$\\,$}||';
for i=1:nfun
    firstline = strcat([firstline,'@{$\\,$}c@{$\\,$}|']);
end
firstline = strcat([firstline,'}\n']);
fprintf(fid,firstline);
fprintf(fid,'\\hline\n');
labelline = 'FES & Prob.';
for i=fnumbers
    labelline = strcat([labelline,' & ',num2str(i)]);
end
labelline= strcat([labelline,' \\\\ \n']);
fprintf(fid,labelline);
fprintf(fid,'\\hline \n \\hline \n');
ids = {'min','$7^{th}$','med.','$19^{th}$','max','mean','std'};
maxeval = dim*10000;
for i=1:size(table,1)
    id = ids{mod(i-1,7)+1};
    if i==4
        fprintf(fid,'$1\\mathrm{e}3$ & %s ',id);
    elseif i==11
        fprintf(fid,'$1\\mathrm{e}4$ & %s ',id);
    elseif i==18
        fprintf(fid,'$1\\mathrm{e}5$ & %s ',id);
    elseif i==25
        fprintf(fid,'$%1.0d\\mathrm{e}5$ & %s ',dim/10,id);
    else
        fprintf(fid,'    & %s ',id); 
    end    
    
    for j=1:nfun 
        fprintf(fid,' & $%4.2e$',table(i,j));
    end
    fprintf(fid,' \\\\ \n');
    if mod(i,7)==0
       fprintf(fid,' \\hline \n \\hline \n');
    else
       fprintf(fid,' \\cline{2-%d}\n',nfun+2);
    end
end
fprintf(fid,'\\end{tabular}\n');
fprintf(fid,'}\n');
fprintf(fid,'\\end{center}\n');
fprintf(fid,'\\end{table}\n');
fclose(fid);
% write table to tex file
% \begin{tabular}[t]{lrr@{.}l}
%    Position 1 & DM & 5 & 49\\
%    Position 2 & DM & 10 & 95\\
%    ...
%\end{tabular}
