function dummy=cecperftextab(dim)
dummy = [];


% open outfile
outfile = strcat(['performance_',num2str(dim),'D.tex']);
fid = fopen(outfile,'w');
fprintf(fid,'\\begin{table}\n');
fprintf(fid,'\\begin{center}\n');
fprintf(fid,'{\\scriptsize\n');
fprintf(fid,'\\caption{caption...}\n');
firstline = '\\begin{tabular}{|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|@{$\\,$}c@{$\\,$}|}\n';
fprintf(fid,firstline);

fprintf(fid,'\\hline\n');

labelline2 = 'Prob. & min & $7^{th}$ & median & $19^{th}$ & max & mean & std & rate & performance \\\\ \n';
labelline1 = '& & & & & & & & success & success \\\\ \n';
fprintf(fid,labelline1);
fprintf(fid,labelline2);
fprintf(fid,'\\hline \n \\hline \n');
% write header


% loop over all functions
table = zeros(25,9);
for i = 1:25
    % file and directory names
    filename = strcat(['performance_f',num2str(i),'_',num2str(dim),'D.dat']);
    dirname  = strcat(['fun',num2str(i)]);
    
    % change wdir 
    eval(['cd ',dirname]);
    
    % read data 
    fidin = fopen(filename,'r');
    if (fidin ==-1)
        disp(filename);
        warning('file not found!');                           
        table(i,:) = NaN;
    else
        numbers = zeros(1,7);
        successrate  = fscanf(fidin,'%f',1);
        numbers      = fscanf(fidin,'%f',7);
        table(i,1:7) = numbers;
        table(i,8)   = successrate;
        if isfinite(successrate)
            table(i,9) = numbers(6)/successrate;
        else
            table(i,9) = NaN;
        end
    end
    cd ../;
    
    % write line to table
    fprintf(fid,'$%d$',i);
    for j=1:7
        if ~isnan(table(i,j))
            fprintf(fid,' & $%4.2e$',table(i,j));  
        else
            fprintf(fid,' & -');
        end
    end
    if ~isnan(table(i,8))
        fprintf(fid,' & $%3.2f$',table(i,8));  
    else
        fprintf(fid,' & $%3.2f$',0.0);
    end
    if ~isnan(table(i,9))
        fprintf(fid,' & $%4.2e$',table(i,9));  
    else
        fprintf(fid,' & -');
    end       
    fprintf(fid,' \\\\ \n');
    fprintf(fid,'\\hline \n');        
end
fprintf(fid,'\\hline \n');
fprintf(fid,'\\end{tabular}\n');
fprintf(fid,'}\n');
fprintf(fid,'\\end{center}\n');
fprintf(fid,'\\end{table}\n');
fclose(fid);